#' OpenAPI Petstore
#'
#' This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#'
#' The version of the OpenAPI document: 1.0.0
#' Generated by: https://openapi-generator.tech
#'

#' @docType class
#' @title AllofTagApiResponse
#' @description AllofTagApiResponse Class
#' @format An \code{R6Class} generator object
#' @field id  integer [optional]
#' @field name  character [optional]
#' @field code  integer [optional]
#' @field type  character [optional]
#' @field message  character [optional]
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
AllofTagApiResponse <- R6::R6Class(
  'AllofTagApiResponse',
  public = list(
    `id` = NULL,
    `name` = NULL,
    `code` = NULL,
    `type` = NULL,
    `message` = NULL,
    #' Initialize a new AllofTagApiResponse class.
    #'
    #' @description
    #' Initialize a new AllofTagApiResponse class.
    #'
    #' @param id id
    #' @param name name
    #' @param code code
    #' @param type type
    #' @param message message
    #' @param ... Other optional arguments.
    #' @export
    initialize = function(
        `id`=NULL, `name`=NULL, `code`=NULL, `type`=NULL, `message`=NULL, ...
    ) {
      if (!is.null(`id`)) {
        stopifnot(is.numeric(`id`), length(`id`) == 1)
        self$`id` <- `id`
      }
      if (!is.null(`name`)) {
        stopifnot(is.character(`name`), length(`name`) == 1)
        self$`name` <- `name`
      }
      if (!is.null(`code`)) {
        stopifnot(is.numeric(`code`), length(`code`) == 1)
        self$`code` <- `code`
      }
      if (!is.null(`type`)) {
        stopifnot(is.character(`type`), length(`type`) == 1)
        self$`type` <- `type`
      }
      if (!is.null(`message`)) {
        stopifnot(is.character(`message`), length(`message`) == 1)
        self$`message` <- `message`
      }
    },
    #' To JSON string
    #'
    #' @description
    #' To JSON String
    #'
    #' @return AllofTagApiResponse in JSON format
    #' @export
    toJSON = function() {
      AllofTagApiResponseObject <- list()
      if (!is.null(self$`id`)) {
        AllofTagApiResponseObject[['id']] <-
          self$`id`
      }
      if (!is.null(self$`name`)) {
        AllofTagApiResponseObject[['name']] <-
          self$`name`
      }
      if (!is.null(self$`code`)) {
        AllofTagApiResponseObject[['code']] <-
          self$`code`
      }
      if (!is.null(self$`type`)) {
        AllofTagApiResponseObject[['type']] <-
          self$`type`
      }
      if (!is.null(self$`message`)) {
        AllofTagApiResponseObject[['message']] <-
          self$`message`
      }

      AllofTagApiResponseObject
    },
    #' Deserialize JSON string into an instance of AllofTagApiResponse
    #'
    #' @description
    #' Deserialize JSON string into an instance of AllofTagApiResponse
    #'
    #' @param AllofTagApiResponseJson the JSON input
    #' @return the instance of AllofTagApiResponse
    #' @export
    fromJSON = function(AllofTagApiResponseJson) {
      AllofTagApiResponseObject <- jsonlite::fromJSON(AllofTagApiResponseJson)
      if (!is.null(AllofTagApiResponseObject$`id`)) {
        self$`id` <- AllofTagApiResponseObject$`id`
      }
      if (!is.null(AllofTagApiResponseObject$`name`)) {
        self$`name` <- AllofTagApiResponseObject$`name`
      }
      if (!is.null(AllofTagApiResponseObject$`code`)) {
        self$`code` <- AllofTagApiResponseObject$`code`
      }
      if (!is.null(AllofTagApiResponseObject$`type`)) {
        self$`type` <- AllofTagApiResponseObject$`type`
      }
      if (!is.null(AllofTagApiResponseObject$`message`)) {
        self$`message` <- AllofTagApiResponseObject$`message`
      }
      self
    },
    #' To JSON string
    #'
    #' @description
    #' To JSON String
    #'
    #' @return AllofTagApiResponse in JSON format
    #' @export
    toJSONString = function() {
      jsoncontent <- c(
        if (!is.null(self$`id`)) {
        sprintf(
        '"id":
          %d
                ',
        self$`id`
        )},
        if (!is.null(self$`name`)) {
        sprintf(
        '"name":
          "%s"
                ',
        self$`name`
        )},
        if (!is.null(self$`code`)) {
        sprintf(
        '"code":
          %d
                ',
        self$`code`
        )},
        if (!is.null(self$`type`)) {
        sprintf(
        '"type":
          "%s"
                ',
        self$`type`
        )},
        if (!is.null(self$`message`)) {
        sprintf(
        '"message":
          "%s"
                ',
        self$`message`
        )}
      )
      jsoncontent <- paste(jsoncontent, collapse = ",")
      paste('{', jsoncontent, '}', sep = "")
    },
    #' Deserialize JSON string into an instance of AllofTagApiResponse
    #'
    #' @description
    #' Deserialize JSON string into an instance of AllofTagApiResponse
    #'
    #' @param AllofTagApiResponseJson the JSON input
    #' @return the instance of AllofTagApiResponse
    #' @export
    fromJSONString = function(AllofTagApiResponseJson) {
      AllofTagApiResponseObject <- jsonlite::fromJSON(AllofTagApiResponseJson)
      self$`id` <- AllofTagApiResponseObject$`id`
      self$`name` <- AllofTagApiResponseObject$`name`
      self$`code` <- AllofTagApiResponseObject$`code`
      self$`type` <- AllofTagApiResponseObject$`type`
      self$`message` <- AllofTagApiResponseObject$`message`
      self
    },
    #' Validate JSON input with respect to AllofTagApiResponse
    #'
    #' @description
    #' Validate JSON input with respect to AllofTagApiResponse and throw an exception if invalid
    #'
    #' @param input the JSON input
    #' @export
    validateJSON = function(input) {
      input_json <- jsonlite::fromJSON(input)
    }

  )
)

