#' OpenAPI Petstore
#'
#' This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#'
#' The version of the OpenAPI document: 1.0.0
#' Generated by: https://openapi-generator.tech
#'

#' @docType class
#' @title AnyOfPig
#'
#' @description AnyOfPig Class
#'
#' @format An \code{R6Class} generator object
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
AnyOfPig <- R6::R6Class(
  'AnyOfPig',
  public = list(
    #' @field actual_instance the object stored in this instance.
    actual_instance = NULL,
    #' @field actual_type the type of the object stored in this instance.
    actual_type = NULL,
    #' @field any_of  a list of object types defined in the anyOf schema.
    any_of = list("BasquePig", "DanishPig"),
    #' Initialize a new AnyOfPig.
    #'
    #' @description
    #' Initialize a new AnyOfPig.
    #'
    #' @param instance an instance of the object defined in the anyOf schemas: "BasquePig", "DanishPig"
    #' @export
    initialize = function(instance = NULL) {
      if (is.null(instance)) {
        # do nothing
      } else if (get(class(instance)[[1]], pos = -1)$classname ==  "BasquePig") {
        self$actual_instance = instance
        self$actual_type = "BasquePig"
      } else if (get(class(instance)[[1]], pos = -1)$classname ==  "DanishPig") {
        self$actual_instance = instance
        self$actual_type = "DanishPig"
      } else {
        stop(paste("Failed to initialize AnyOfPig with anyOf schemas BasquePig, DanishPig. Provided class name: ", get(class(instance)[[1]], pos = -1)$classname))
      }
    },
    #' Deserialize JSON string into an instance of AnyOfPig.
    #'
    #' @description
    #' Deserialize JSON string into an instance of AnyOfPig.
    #'
    #' @param input The input JSON.
    #' @return An instance of AnyOfPig.
    #' @export
    fromJSON = function(input) {
      error_messages <- list()

      BasquePig_result <- tryCatch({
          BasquePig$public_methods$validateJSON(input)
          BasquePig_instance <- BasquePig$new()
          self$actual_instance <- BasquePig_instance$fromJSON(input)
          self$actual_type <- "BasquePig"
          return(self)
        },
        error = function(err) err
      )

      if (!is.null(BasquePig_result['error'])) {
        error_messages <- append(error_messages, BasquePig_result['message'])
      }

      DanishPig_result <- tryCatch({
          DanishPig$public_methods$validateJSON(input)
          DanishPig_instance <- DanishPig$new()
          self$actual_instance <- DanishPig_instance$fromJSON(input)
          self$actual_type <- "DanishPig"
          return(self)
        },
        error = function(err) err
      )

      if (!is.null(DanishPig_result['error'])) {
        error_messages <- append(error_messages, DanishPig_result['message'])
      }

      # no match
      stop(paste("No match found when deserializing the payload into AnyOfPig with anyOf schemas BasquePig, DanishPig. Details: ", paste(error_messages, collapse = ', ')))
    },
    #' Serialize AnyOfPig to JSON string.
    #'
    #' @description
    #' Serialize AnyOfPig to JSON string.
    #'
    #' @return JSON string reprenation of the AnyOfPig.
    #' @export
    toJSON = function() {
      if (!is.null(self$actual_instance)) {
        self$actual_instance$toJSONString()
      } else {
        NULL
      }
    },
    #' Validate the input JSON with respect to AnyOfPig.
    #'
    #' @description
    #' Validate the input JSON with respect to AnyOfPig and
    #' throw exception if invalid.
    #'
    #' @param input The input JSON.
    #' @export
    validateJSON = function(input) {
      # backup current values
      actual_instance_bak <- self$actual_instance
      actual_type_bak <- self$actual_type

      # if it's not valid, an error will be thrown
      self$fromJSON(input)

      # no error thrown, restore old values
      self$actual_instance <- actual_instance_bak
      self$actual_type <- actual_type_bak
    }
  )
)

