#' OpenAPI Petstore
#'
#' This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#'
#' The version of the OpenAPI document: 1.0.0
#' Generated by: https://openapi-generator.tech
#'

#' @docType class
#' @title Dog
#' @description Dog Class
#' @format An \code{R6Class} generator object
#' @field className  character 
#' @field color  character [optional]
#' @field breed  character [optional]
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Dog <- R6::R6Class(
  'Dog',
  inherit = Animal,
  public = list(
    `className` = NULL,
    `color` = NULL,
    `breed` = NULL,
    #' Initialize a new Dog class.
    #'
    #' @description
    #' Initialize a new Dog class.
    #'
    #' @param className className
    #' @param color color. Default to 'red'.
    #' @param breed breed
    #' @param ... Other optional arguments.
    #' @export
    initialize = function(
        `className`, `color`='red', `breed`=NULL, ...
    ) {
      if (!missing(`className`)) {
        stopifnot(is.character(`className`), length(`className`) == 1)
        self$`className` <- `className`
      }
      if (!is.null(`color`)) {
        stopifnot(is.character(`color`), length(`color`) == 1)
        self$`color` <- `color`
      }
      if (!is.null(`breed`)) {
        stopifnot(is.character(`breed`), length(`breed`) == 1)
        self$`breed` <- `breed`
      }
    },
    #' To JSON string
    #'
    #' @description
    #' To JSON String
    #'
    #' @return Dog in JSON format
    #' @export
    toJSON = function() {
      DogObject <- list()
      if (!is.null(self$`className`)) {
        DogObject[['className']] <-
          self$`className`
      }
      if (!is.null(self$`color`)) {
        DogObject[['color']] <-
          self$`color`
      }
      if (!is.null(self$`breed`)) {
        DogObject[['breed']] <-
          self$`breed`
      }

      DogObject
    },
    #' Deserialize JSON string into an instance of Dog
    #'
    #' @description
    #' Deserialize JSON string into an instance of Dog
    #'
    #' @param DogJson the JSON input
    #' @return the instance of Dog
    #' @export
    fromJSON = function(DogJson) {
      DogObject <- jsonlite::fromJSON(DogJson)
      if (!is.null(DogObject$`className`)) {
        self$`className` <- DogObject$`className`
      }
      if (!is.null(DogObject$`color`)) {
        self$`color` <- DogObject$`color`
      }
      if (!is.null(DogObject$`breed`)) {
        self$`breed` <- DogObject$`breed`
      }
      self
    },
    #' To JSON string
    #'
    #' @description
    #' To JSON String
    #'
    #' @return Dog in JSON format
    #' @export
    toJSONString = function() {
      jsoncontent <- c(
        if (!is.null(self$`className`)) {
        sprintf(
        '"className":
          "%s"
                ',
        self$`className`
        )},
        if (!is.null(self$`color`)) {
        sprintf(
        '"color":
          "%s"
                ',
        self$`color`
        )},
        if (!is.null(self$`breed`)) {
        sprintf(
        '"breed":
          "%s"
                ',
        self$`breed`
        )}
      )
      jsoncontent <- paste(jsoncontent, collapse = ",")
      paste('{', jsoncontent, '}', sep = "")
    },
    #' Deserialize JSON string into an instance of Dog
    #'
    #' @description
    #' Deserialize JSON string into an instance of Dog
    #'
    #' @param DogJson the JSON input
    #' @return the instance of Dog
    #' @export
    fromJSONString = function(DogJson) {
      DogObject <- jsonlite::fromJSON(DogJson)
      self$`className` <- DogObject$`className`
      self$`color` <- DogObject$`color`
      self$`breed` <- DogObject$`breed`
      self
    },
    #' Validate JSON input with respect to Dog
    #'
    #' @description
    #' Validate JSON input with respect to Dog and throw an exception if invalid
    #'
    #' @param input the JSON input
    #' @export
    validateJSON = function(input) {
      input_json <- jsonlite::fromJSON(input)
      # check the required field `className`
      if (!is.null(input_json$`className`)) {
        stopifnot(is.character(input_json$`className`), length(input_json$`className`) == 1)
      } else {
        stop(paste("The JSON input `", input, "` is invalid for Dog: the required field `className` is missing."))
      }
    }

  )
)

