#' OpenAPI Petstore
#'
#' This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#'
#' The version of the OpenAPI document: 1.0.0
#' Generated by: https://openapi-generator.tech
#'

#' @docType class
#' @title Special
#' @description Special Class
#' @format An \code{R6Class} generator object
#' @field item_self  integer [optional]
#' @field item_private  character [optional]
#' @field item_super  character [optional]
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Special <- R6::R6Class(
  'Special',
  public = list(
    `item_self` = NULL,
    `item_private` = NULL,
    `item_super` = NULL,
    #' Initialize a new Special class.
    #'
    #' @description
    #' Initialize a new Special class.
    #'
    #' @param item_self item_self
    #' @param item_private item_private
    #' @param item_super item_super
    #' @param ... Other optional arguments.
    #' @export
    initialize = function(
        `item_self`=NULL, `item_private`=NULL, `item_super`=NULL, ...
    ) {
      if (!is.null(`item_self`)) {
        stopifnot(is.numeric(`item_self`), length(`item_self`) == 1)
        self$`item_self` <- `item_self`
      }
      if (!is.null(`item_private`)) {
        stopifnot(is.character(`item_private`), length(`item_private`) == 1)
        self$`item_private` <- `item_private`
      }
      if (!is.null(`item_super`)) {
        stopifnot(is.character(`item_super`), length(`item_super`) == 1)
        self$`item_super` <- `item_super`
      }
    },
    #' To JSON string
    #'
    #' @description
    #' To JSON String
    #'
    #' @return Special in JSON format
    #' @export
    toJSON = function() {
      SpecialObject <- list()
      if (!is.null(self$`item_self`)) {
        SpecialObject[['self']] <-
          self$`item_self`
      }
      if (!is.null(self$`item_private`)) {
        SpecialObject[['private']] <-
          self$`item_private`
      }
      if (!is.null(self$`item_super`)) {
        SpecialObject[['super']] <-
          self$`item_super`
      }

      SpecialObject
    },
    #' Deserialize JSON string into an instance of Special
    #'
    #' @description
    #' Deserialize JSON string into an instance of Special
    #'
    #' @param SpecialJson the JSON input
    #' @return the instance of Special
    #' @export
    fromJSON = function(SpecialJson) {
      SpecialObject <- jsonlite::fromJSON(SpecialJson)
      if (!is.null(SpecialObject$`self`)) {
        self$`item_self` <- SpecialObject$`self`
      }
      if (!is.null(SpecialObject$`private`)) {
        self$`item_private` <- SpecialObject$`private`
      }
      if (!is.null(SpecialObject$`super`)) {
        self$`item_super` <- SpecialObject$`super`
      }
      self
    },
    #' To JSON string
    #'
    #' @description
    #' To JSON String
    #'
    #' @return Special in JSON format
    #' @export
    toJSONString = function() {
      jsoncontent <- c(
        if (!is.null(self$`item_self`)) {
        sprintf(
        '"self":
          %d
                ',
        self$`item_self`
        )},
        if (!is.null(self$`item_private`)) {
        sprintf(
        '"private":
          "%s"
                ',
        self$`item_private`
        )},
        if (!is.null(self$`item_super`)) {
        sprintf(
        '"super":
          "%s"
                ',
        self$`item_super`
        )}
      )
      jsoncontent <- paste(jsoncontent, collapse = ",")
      paste('{', jsoncontent, '}', sep = "")
    },
    #' Deserialize JSON string into an instance of Special
    #'
    #' @description
    #' Deserialize JSON string into an instance of Special
    #'
    #' @param SpecialJson the JSON input
    #' @return the instance of Special
    #' @export
    fromJSONString = function(SpecialJson) {
      SpecialObject <- jsonlite::fromJSON(SpecialJson)
      self$`item_self` <- SpecialObject$`item_self`
      self$`item_private` <- SpecialObject$`item_private`
      self$`item_super` <- SpecialObject$`item_super`
      self
    },
    #' Validate JSON input with respect to Special
    #'
    #' @description
    #' Validate JSON input with respect to Special and throw an exception if invalid
    #'
    #' @param input the JSON input
    #' @export
    validateJSON = function(input) {
      input_json <- jsonlite::fromJSON(input)
    }

  )
)

